org.bouncycastle.crypto.modes

## Class G3413CTRBlockCipher

- java.lang.Object
- - org.bouncycastle.crypto.DefaultMultiBlockCipher
  - - org.bouncycastle.crypto.StreamBlockCipher
    - - org.bouncycastle.crypto.modes.G3413CTRBlockCipher

- All Implemented Interfaces:
    BlockCipher, MultiBlockCipher, StreamCipher

      public class G3413CTRBlockCipher
      extends StreamBlockCipher

  implements the GOST 3412 2015 CTR counter mode (GCTR).

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `G3413CTRBlockCipher(BlockCipher cipher)` Basic constructor.
    `G3413CTRBlockCipher(BlockCipher cipher, int bitBlockSize)` Basic constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected byte` | `calculateByte(byte in)`
    `java.lang.String` | `getAlgorithmName()` return the algorithm name and mode.
    `int` | `getBlockSize()` return the block size we are operating at (in bytes).
    `void` | `init(boolean encrypting, CipherParameters params)` Initialise the cipher and, possibly, the initialisation vector (IV).
    `int` | `processBlock(byte[] in, int inOff, byte[] out, int outOff)` Process one block of input from the array in and write it to the out array.
    `void` | `reset()` reset the feedback vector back to the IV and reset the underlying cipher.

    - ### Methods inherited from class org.bouncycastle.crypto.StreamBlockCipher

      `getUnderlyingCipher, processBytes, returnByte`

    - ### Methods inherited from class org.bouncycastle.crypto.DefaultMultiBlockCipher

      `getMultiBlockSize, processBlocks`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### G3413CTRBlockCipher

          public G3413CTRBlockCipher(BlockCipher cipher)

      Basic constructor.
      Parameters:
        `cipher` - the block cipher to be used as the basis of the counter mode (must have a 64 bit block size).

    - #### G3413CTRBlockCipher

          public G3413CTRBlockCipher(BlockCipher cipher,
                                     int bitBlockSize)

      Basic constructor.
      Parameters:
        `cipher` - the block cipher to be used as the basis of the counter mode (must have a 64 bit block size).
        `bitBlockSize` - basic unit (defined as s)

  - ### Method Detail

    - #### init

          public void init(boolean encrypting,
                           CipherParameters params)
                    throws java.lang.IllegalArgumentException

      Initialise the cipher and, possibly, the initialisation vector (IV). If an IV isn't passed as part of the parameter, the IV will be all zeros. An IV which is too short is handled in FIPS compliant fashion.
      Parameters:
        `encrypting` - if true the cipher is initialised for encryption, if false for decryption.
        `params` - the key and other data required by the cipher.
      Throws:
        `java.lang.IllegalArgumentException` - if the params argument is inappropriate.

    - #### getAlgorithmName

          public java.lang.String getAlgorithmName()

      return the algorithm name and mode.
      Returns:
        the name of the underlying algorithm followed by "/GCTR" and the block size in bits

    - #### getBlockSize

          public int getBlockSize()

      return the block size we are operating at (in bytes).
      Returns:
        the block size we are operating at (in bytes).

    - #### processBlock

          public int processBlock(byte[] in,
                                  int inOff,
                                  byte[] out,
                                  int outOff)
                           throws DataLengthException,
                                  java.lang.IllegalStateException

      Process one block of input from the array in and write it to the out array.
      Parameters:
        `in` - the array containing the input data.
        `inOff` - offset into the in array the data starts at.
        `out` - the array the output data will be copied into.
        `outOff` - the offset into the out array the output will start at.
      Returns:
        the number of bytes processed and produced.
      Throws:
        `DataLengthException` - if there isn't enough data in in, or space in out.
        `java.lang.IllegalStateException` - if the cipher isn't initialised.

    - #### calculateByte

          protected byte calculateByte(byte in)

      Specified by:
        `calculateByte` in class `StreamBlockCipher`

    - #### reset

          public void reset()

      reset the feedback vector back to the IV and reset the underlying cipher.